/*
 * JSON-RPC-Java - a JSON-RPC to Java Bridge with dynamic invocation
 *
 * $Id: ObjectMatch.java,v 1.2 2005/02/24 03:05:51 mclark Exp $
 *
 * Copyright Metaparadigm Pte. Ltd. 2004.
 * Michael Clark <michael@metaparadigm.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public (LGPL)
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details: http://www.gnu.org/
 *
 */

package com.metaparadigm.jsonrpc;

/**
 * This class is returned from the Serializer tryUnmarshall method to
 * indicate number of mismatched fields. This is used to handle ambiguities
 * with JavaScript's typeless objects combined with and Java's operator
 * overloading.
 */

public class ObjectMatch
{
    public final static ObjectMatch OKAY = new ObjectMatch(-1);
    public final static ObjectMatch NULL = new ObjectMatch(0);

    protected int mismatch;

    public ObjectMatch(int mismatch)
    {
	this.mismatch = mismatch;
    }

    public ObjectMatch max(ObjectMatch m)
    {
	if(this.mismatch > m.mismatch) return this;
	return m;
    }
}
